<template>
  <div class="main">
    <h1 class="title">
      {{ $t('embed.title') }}
    </h1>
    <p class="mb-8">
      {{ $t('embed.text') }}
    </p>
    <div
      class="embedding-code"
      ref="embeddingCode"
    >
      &lt;iframe
        src="{{ urlForProjectPlayer }}"
        width="{{embedWidth}}"
        height="{{embedHeight}}"
        allowtransparency="true"
        allow="microphone; camera"
        frameborder="0"
        scrolling="no"
        allowfullscreen&gt;
      &lt;/iframe&gt;
    </div>

    <div class="flex justify-end">
      <button
        class="ada-button"
        type="button"
        :title="$t('embed.copyActionAlt')"
        @click="copyEmbeddingCodeToClipBoard"
      >
        {{ $t('embed.copyAction') }}
      </button>
    </div>

    <div class="mt-8">
      {{ $t('embed.sizeText') }}
      <div class="embedding-size">
        <label class="label-layout">
          <input
            type="radio"
            class="form-radio"
            name="embedSize"
            value="800 × 450"
            v-model="sizeChoice"
          >
          <span class="ml-2">800 × 450</span>
        </label>
        <label class="label-layout">
          <input
            type="radio"
            class="form-radio"
            name="embedSize"
            value="480 × 270"
            v-model="sizeChoice"
          >
          <span class="ml-2">480 × 270</span>
        </label>
        <label class="label-layout">
          <input
            type="radio"
            class="form-radio"
            name="embedSize"
            value="custom"
            v-model="sizeChoice"
          >
          <span class="ml-2">{{ $t('embed.customWidth') }}</span>
          <input
            type="number"
            class="ada-text-input ml-4 w-1/4"
            v-model="customEmbedWidth"
          >
        </label>
      </div>
      <div class="mt-8">
        <label class="label-layout">
          <input
            type="checkbox"
            class="form-checkbox"
            name="start"
            value=false
            v-model="startModeChoice"
          >
          <span class="ml-2">{{ $t('embed.startText') }}</span>
        </label>
      </div>
      <div class="mt-8">
        {{ $t('embed.controlText') }}
        <div class="embedding-control">
          <label class="label-layout">
            <input
              type="checkbox"
              class="form-checkbox"
              name="main"
              value=true
              checked
              v-model="mainControlChoice"
            >
            <span class="ml-2">{{ $t('embed.mainControl') }}</span>
          </label>
          <label class="label-layout">
            <input
              type="checkbox"
              class="form-checkbox"
              name="fullscreen"
              value=true
              checked
              v-model="fullscreenControlChoice"
            >
            <span class="ml-2">{{ $t('embed.fullscreenControl') }}</span>
          </label>
        </div>
      </div>
    </div>

  </div>
</template>

<script>
import { computed, ref } from 'vue'


const selectText = function (element) {
  const range = document.createRange()
  range.selectNode(element)
  window.getSelection().removeAllRanges()
  window.getSelection().addRange(range)
}

export default {
  name: 'ProjectEmbedSettings',
  props: {
    uid: {
      type: String,
      required: true
    }
  },
  setup () {
    const customEmbedWidth = ref(960)
    const sizeChoice = ref('800 × 450')
    const embedWidth = computed(() => {
      if (sizeChoice.value === '800 × 450') {
        return 800
      } else if (sizeChoice.value === '480 × 270') {
        return 480
      } else if (sizeChoice.value === 'custom') {
        return customEmbedWidth.value
      } else {
        return 800
      }
    })
    const embedHeight = computed(() => {
      return Math.floor((embedWidth.value*9)/16)
    })
    const startModeChoice = ref(false)
    const embedStartMode = computed(() => {
      if (startModeChoice.value === true) {
        return '&start=auto'
      } else {
        return ''
      }
    })
    const mainControlChoice = ref(true)
    const fullscreenControlChoice = ref(true)
    const embedControlChoice = computed(() => {
      if (mainControlChoice.value === true && fullscreenControlChoice.value === true) {
        return ''
      } else if (mainControlChoice.value === true && fullscreenControlChoice.value === false) {
        return '&controls=main'
      } else if (mainControlChoice.value === false && fullscreenControlChoice.value === true) {
        return '&controls=fullscreen'
      } else {
        return '&controls=none'
      }
    })

    return {
      embedWidth,
      embedHeight,
      customEmbedWidth,
      sizeChoice,
      startModeChoice,
      embedStartMode,
      mainControlChoice,
      fullscreenControlChoice,
      embedControlChoice
    }
  },
  computed: {
    urlForProjectPlayer () {
      const origin = window.location.origin
      return `${origin}/player?project=${this.uid}${this.embedStartMode}${this.embedControlChoice}`
    }
  },
  methods: {
    copyEmbeddingCodeToClipBoard () {
      selectText(this.$refs.embeddingCode)
      document.execCommand('copy')
    }
  }
}
</script>

<style lang="postcss" scoped>
.main {
  @apply text-base text-gray-700;
  @apply dark:text-gray-400;
}

.title {
  @apply mb-8;
  @apply text-gray-900 text-xl text-center font-semibold;
  @apply dark:text-gray-300;
}

.embedding-code {
  @apply m-2 p-4;
  @apply font-mono text-xs;
  @apply border-gray-100 border-2;
  @apply dark:border-gray-700;
}

.embedding-size, .embedding-control {
  @apply flex flex-col;
  @apply ml-10 mt-3;
}

.label-layout {
  @apply inline-flex items-center;
}
</style>